DECLARE FUNCTION findturn% (oa%, ea%)
DECLARE SUB edloc (gx%, gy%)
DECLARE FUNCTION gview% (a1%, a2%)
'$DYNAMIC



DEFINT A-Z

DECLARE SUB loadmap (n$)
DECLARE SUB savemap (n$)
DECLARE SUB dobkg (a%, va%)
DECLARE SUB mksprite ()
DECLARE FUNCTION edpnt% (x%, y%)
'$INCLUDE: 'directqb.bi'

DECLARE SUB dpnts (x%, y%, z%, ax%, ay%, az%)
DECLARE FUNCTION edangle% (a%)
DECLARE SUB dpoly (a%, va%)
DECLARE SUB makepmap ()
DECLARE SUB lutsc ()
DECLARE SUB makepoly ()


TYPE ddpnt
 x AS INTEGER
 y AS INTEGER
END TYPE

TYPE pntdat
 x AS INTEGER
 y AS INTEGER
 z AS INTEGER
 vz AS INTEGER
 sx AS INTEGER
 sy AS INTEGER
 ss AS INTEGER
 effect AS INTEGER
 effdat1 AS INTEGER
 effdat2 AS INTEGER
 effdat3 AS INTEGER
END TYPE

TYPE textdat
 p1 AS ddpnt
 p2 AS ddpnt
 p3 AS ddpnt
END TYPE

TYPE polydat
 v1 AS INTEGER
 v2 AS INTEGER
 v3 AS INTEGER
 v4 AS INTEGER
 ord AS INTEGER
  ge1 AS INTEGER
  ge2 AS INTEGER
  tex1 AS INTEGER
   tdat1 AS textdat
  tex2 AS INTEGER
   tdat2 AS textdat
    teffect1 AS INTEGER
    teffect2 AS INTEGER
END TYPE

TYPE objdat
 x AS INTEGER
 y AS INTEGER
 z AS INTEGER
  ax AS INTEGER
  ay AS INTEGER
  az AS INTEGER
   p1 AS INTEGER
   p2 AS INTEGER
   p3 AS INTEGER
END TYPE
 
REDIM SHARED pnt(256) AS pntdat
REDIM SHARED poly(15, 15) AS polydat
REDIM SHARED smap(15, 15) AS INTEGER
REDIM SHARED buff1(31999) AS INTEGER
REDIM SHARED buff2(31999) AS INTEGER
REDIM SHARED Buff3(31999) AS INTEGER
REDIM SHARED obj(2) AS objdat
DIM SHARED co(360) AS SINGLE
DIM SHARED si(360) AS SINGLE
DIM SHARED focal AS INTEGER
DIM SHARED goff AS INTEGER
DIM SHARED palt AS STRING * 768
DIM rpal AS STRING * 768
DIM SHARED px, py, pz, pa AS INTEGER

goff = ((32 * 32) / 2) + 4

focal = 95


i = DQBinit(2, 0)
IF i <> 0 THEN END

CALL DQBinitVGA
CALL DQBgetpal(rpal)
CALL DQBprint(0, "XENO engine version: 1", 1, 1, 15)

CALL lutsc
CALL makepmap
CALL makepoly




CALL mksprite
CALL DQBsettexturesize(32)


gy = 1
gx = 1
pax = 50
pay = 0
paz = 0

fc = 0
st& = TIMER

bx = INT(RND * 15) + 1
by = INT(RND * 15) + 1
bsy = 1: bsx = 1
t1 = INT(RND * 2)
t2 = INT(RND * 2)
IF t1 = 0 THEN bsx = -1
IF t2 = 0 THEN bsy = -1

k = 199

CALL loadmap("pack4.pkg")

CALL DQBfadeto(63, 63, 63)
st = 1

CALL edloc(gx, gy)
DO

k = k + 1
IF k > 255 THEN k = 199

CALL dpnts(obj(0).x, obj(0).y, obj(0).z, obj(0).ax, obj(0).ay, obj(0).az)



CALL DQBcopylayer(1, VIDEO)
pt = pt - 1
IF pt < 0 THEN pt = 0

SELECT CASE INKEY$
 CASE CHR$(27)
  done = 1

 CASE "=", "+"
  focal = focal - 5
 CASE "-", "_"
  focal = focal + 5

 CASE CHR$(0) + CHR$(75)
  IF pt = 0 THEN
    pt = 4
  pa = edangle%(pa + 45)
    END IF
 CASE CHR$(0) + CHR$(77)
  IF pt = 0 THEN
   pt = 4
  pa = edangle%(pa - 45)
  END IF
 CASE CHR$(0) + CHR$(72)
   
   IF pt = 0 THEN
    pt = 4
    SELECT CASE INT(pa / 45)
     CASE 0
      ngx = 0: ngy = -1
     CASE 1
      ngx = -1: ngy = -1
     CASE 2
      ngx = -1: ngy = 0
     CASE 3
      ngx = -1: ngy = 1
     CASE 4
      ngx = 0: ngy = 1
     CASE 5
      ngx = 1: ngy = 1
     CASE 6
      ngx = 1: ngy = 0
     CASE 7
      ngx = 1: ngy = -1
    END SELECT
 
   nx = gx + ngx
   ny = gy + ngy
     IF nx > 15 THEN nx = 15
     IF nx < 1 THEN nx = 1
     IF ny > 15 THEN ny = 15
     IF ny < 1 THEN ny = 1
      
      IF poly(nx, ny).ge1 = 1 THEN
       gx = nx: gy = ny
      END IF
       tt = edpnt%(gx, gy)
      
       CALL edloc(gx, gy)

  END IF

CASE "a", "A"
 pax = pax - 3
  IF pax < 20 THEN pax = 20
CASE "z", "Z"
 pax = pax + 3
  IF pax > 70 THEN pax = 70


END SELECT

obj(0).x = obj(0).x + ((px - obj(0).x) * .1)
obj(0).y = obj(0).y + ((py - obj(0).y) * .1)
obj(0).z = obj(0).z + ((pz - obj(0).z) * .1)
obj(0).ax = pax'edangle%(obj(0).ax + ((pax - obj(0).ax) * .5))
obj(0).ay = pay'edangle%(obj(0).ay + ((pay - obj(0).ay) * .5))
obj(0).az = edangle%(obj(0).az + (findturn%(obj(0).az, edangle%(360 - pa))) * 5)




 lx = gx: ly = gy
 IF lx > 15 THEN lx = 15
 IF ly > 15 THEN ly = 15
 smap(lx, ly) = 1

IF st = 1 THEN
 CALL DQBfadein(palt)
 st = 0
END IF

ai = ai - 1
IF ai < 0 THEN

bx = bx + bsx
by = by + bsy
 IF bx > 15 THEN bx = 15: bsx = -(bsx)
 IF bx < 1 THEN bx = 1: bsx = -(bsx)
 IF by > 15 THEN by = 15: bsy = -(bsy)
 IF by < 1 THEN by = 1: bsy = -(bsy)

ai = 0
END IF


'smap(bx, by) = 1


LOOP UNTIL done = 1
CALL DQBfadeto(63, 63, 63)

CALL DQBfadeto(0, 0, 0)
CALL DQBclearlayer(0)
CALL DQBfadein(rpal)
CALL DQBinittext

PRINT "XENO engine version 1"
PRINT " 12/18/98 by Darren Morris [MA SNART]"
PRINT : PRINT "SPECIAL THANKS to Angelo for DirectQB"
PRINT "Thanks also to: Danny Gump, Zkman and HAL_8900..."
PRINT "as well as everybody on Tek's QBoard"
PRINT : PRINT "PRESS ANY KEY TO END"
SLEEP

CALL DQBclose


END

REM $STATIC
SUB dobkg (a%, va%)
 tc = 250
 bc = 0

 hv = -((110 - va%) * 1.5)

 nx = a% * 3.555
  
   gv = hv
 
  IF hv < 1 THEN hv = 1
  IF hv > 199 THEN hv = 199
 
CALL DQBboxf(1, 0, 0, 320, hv, tc)
CALL DQBboxf(1, 0, hv, 320, 200, bc)
 
  DO
   IF nx > 319 THEN nx = nx - 320
   IF nx < 0 THEN nx = nx + 320
  LOOP UNTIL nx > -1 AND nx < 320

 
    DQBget 2, nx, 0, 319, 199, VARSEG(Buff3(0)), VARPTR(Buff3(0))
    DQBput 1, 1, gv, VARSEG(Buff3(0)), VARPTR(Buff3(0))
    DQBget 2, 0, 0, nx, 199, VARSEG(Buff3(0)), VARPTR(Buff3(0))
    DQBput 1, 321 - nx, gv, VARSEG(Buff3(0)), VARPTR(Buff3(0))
  
 

END SUB

SUB dpnts (x%, y%, z%, ax%, ay%, az%)

ax% = edangle%(ax%)
ay% = edangle%(ay%)
az% = edangle%(az%)

FOR i = 0 TO 256



 SELECT CASE pnt(i).effect
  CASE 0
   ex = 0: ey = 0: ez = 0
  CASE 10
   ex = 0: ey = 0
    pnt(i).effdat1 = pnt(i).effdat1 + pnt(i).effdat2
     IF pnt(i).effdat1 > 10 THEN pnt(i).effdat2 = -1
     IF pnt(i).effdat1 < -10 THEN pnt(i).effdat2 = 1
   ez = SIN(pnt(i).effdat1) * 2

 END SELECT

 sx& = pnt(i).x + x% + ex
 sy& = pnt(i).y + y% + ey
 sz& = pnt(i).z + z% + ez

     x1& = sx& * co(az%) + sy& * si(az%)
     y1& = sy& * co(az%) - sx& * si(az%)
     z1& = sz&

     x2& = x1&
     y2& = y1& * co(ax%) + z1& * si(ax%)
     z2& = z1& * co(ax%) - y1& * si(ax%)

     x3& = x2& * co(ay%) - z2& * si(ay%)
     y3& = y2&
     z3& = x2& * si(ay%) + z2& * co(ay%)
   
   fx = INT(x3&)
   fy = INT(y3&)
   fz = INT(z3& + focal)
          fz = fz / 10
   
    IF fz < 1 THEN fz = 1
          
    pnt(i).vz = fz

    pnt(i).sx = INT((fx / (fz / 10)) * 1.4) + 160
    pnt(i).sy = INT((fy / (fz / 10)) * 1.3) + 100

 
   pnt(i).ss = 0: d = 0
    IF pnt(i).sx > 0 AND pnt(i).sx < 320 THEN d = d + 1
    IF pnt(i).sy > 0 AND pnt(i).sy < 200 THEN d = d + 1
  
    IF d = 2 THEN pnt(i).ss = 1

NEXT i

CALL dpoly(az%, ax%)
END SUB

SUB dpoly (a%, va%)


'CALL DQBcopylayer(2, 1)
CALL dobkg(a%, va%)
'CALL DQBcopylayer(2, 1)



FOR y = 1 TO 15
FOR x = 1 TO 15

              SELECT CASE a%
                CASE 0 TO 45
                 vx = (15 - x) + 1
                 vy = y
                CASE 46 TO 90
                 vx = (15 - y) + 1
                 vy = x
                CASE 90 TO 120
                 vx = (15 - y) + 1
                 vy = (15 - x) + 1
                CASE 121 TO 180
                 vx = (15 - x) + 1
                 vy = (15 - y) + 1
                CASE 181 TO 225
                 vx = x
                 vy = (15 - y) + 1
               CASE 226 TO 270
                 vx = y
                 vy = (15 - x) + 1
               CASE 271 TO 315
                 vx = y
                 vy = (15 - x) + 1
               CASE 316 TO 361
                 vx = x
                 vy = y
               END SELECT

d = 0


 dx1 = pnt(poly(vx, vy).v1).sx
 dy1 = pnt(poly(vx, vy).v1).sy
  sd1 = pnt(poly(vx, vy).v1).ss
   d = d + sd1

 dx2 = pnt(poly(vx, vy).v2).sx
 dy2 = pnt(poly(vx, vy).v2).sy
  sd2 = pnt(poly(vx, vy).v2).ss
   d = d + sd2

 dx3 = pnt(poly(vx, vy).v3).sx
 dy3 = pnt(poly(vx, vy).v3).sy
  sd3 = pnt(poly(vx, vy).v3).ss
   d = d + sd3

 dx4 = pnt(poly(vx, vy).v4).sx
 dy4 = pnt(poly(vx, vy).v4).sy
  sd4 = pnt(poly(vx, vy).v4).ss
   d = d + sd4


c1 = poly(vx, vy).tex1
c2 = poly(vx, vy).tex2

IF c1 = 41 THEN
  c1 = c1 + poly(vx, vy).teffect1
  poly(vx, vy).teffect1 = poly(vx, vy).teffect1 + 1
   IF poly(vx, vy).teffect1 > 6 THEN poly(vx, vy).teffect1 = 0
END IF

IF c2 = 41 THEN
  c2 = c2 + poly(vx, vy).teffect2
  poly(vx, vy).teffect2 = poly(vx, vy).teffect2 + 1
   IF poly(vx, vy).teffect2 > 6 THEN poly(vx, vy).teffect2 = 0
END IF


'IF poly(vx, vy).ge1 > 0 THEN c1 = -255: c2 = -255

IF d > 0 THEN

r = 0
IF poly(vx, vy).ord = 0 AND a% > 130 THEN r = 1
IF poly(vx, vy).ord = 1 AND a% > 180 THEN r = 1

 p1x1 = poly(vx, vy).tdat1.p1.x: p1x2 = poly(vx, vy).tdat1.p1.x
 p1x2 = poly(vx, vy).tdat1.p2.x: p1y2 = poly(vx, vy).tdat1.p2.y
 p1x3 = poly(vx, vy).tdat1.p3.x: p1y3 = poly(vx, vy).tdat1.p3.y

 p2x1 = poly(vx, vy).tdat2.p1.x: p2x2 = poly(vx, vy).tdat2.p1.x
 p2x2 = poly(vx, vy).tdat2.p2.x: p2y2 = poly(vx, vy).tdat2.p2.y
 p2x3 = poly(vx, vy).tdat2.p3.x: p2y3 = poly(vx, vy).tdat2.p3.y


SELECT CASE r
CASE 0
        SELECT CASE poly(vx, vy).ord
         CASE 0
         
          SELECT CASE c1
           CASE IS < 0
                CALL DQBtri(1, dx1, dy1, dx2, dy2, dx3, dy3, ABS(c1))
           CASE IS > 0
                CALL DQBttri(1, dx1, dy1, dx2, dy2, dx3, dy3, p1x1, p1y1, p1x2, p1y2, p1x3, p1y3, VARSEG(buff2(goff * c1)), VARPTR(buff2(goff * c1)))
           END SELECT
          SELECT CASE c2
           CASE IS < 0
                CALL DQBtri(1, dx1, dy1, dx3, dy3, dx4, dy4, ABS(c2))
           CASE IS > 0
                CALL DQBttri(1, dx1, dy1, dx3, dy3, dx4, dy4, p2x1, p2y1, p2x2, p2y2, p2x3, p2y3, VARSEG(buff2(goff * c2)), VARPTR(buff2(goff * c2)))
           END SELECT
          
         CASE 1
          SELECT CASE c1
           CASE IS < 0
                CALL DQBtri(1, dx2, dy2, dx3, dy3, dx4, dy4, ABS(c1))
           CASE IS > 0
                CALL DQBttri(1, dx2, dy2, dx3, dy3, dx4, dy4, p1x1, p1y1, p1x2, p1y2, p1x3, p1y3, VARSEG(buff2(goff * c1)), VARPTR(buff2(goff * c1)))
           END SELECT
          SELECT CASE c2
           CASE IS < 0
                CALL DQBtri(1, dx2, dy2, dx4, dy4, dx1, dy1, ABS(c2))
           CASE IS > 0
                CALL DQBttri(1, dx2, dy2, dx4, dy4, dx1, dy1, p2x1, p2y1, p2x2, p2y2, p2x3, p2y3, VARSEG(buff2(goff * c2)), VARPTR(buff2(goff * c2)))
           END SELECT
       END SELECT
       
     
CASE 1
        SELECT CASE poly(vx, vy).ord
        CASE 0
          SELECT CASE c2
           CASE IS < 0
                CALL DQBtri(1, dx1, dy1, dx3, dy3, dx4, dy4, ABS(c2))
           CASE IS > 0
                CALL DQBttri(1, dx1, dy1, dx3, dy3, dx4, dy4, p2x1, p2y1, p2x2, p2y2, p2x3, p2y3, VARSEG(buff2(goff * c2)), VARPTR(buff2(goff * c2)))
           END SELECT
          SELECT CASE c1
           CASE IS < 0
                CALL DQBtri(1, dx1, dy1, dx2, dy2, dx3, dy3, ABS(c1))
           CASE IS > 0
                CALL DQBttri(1, dx1, dy1, dx2, dy2, dx3, dy3, p1x1, p1y1, p1x2, p1y2, p1x3, p1y3, VARSEG(buff2(goff * c1)), VARPTR(buff2(goff * c1)))
           END SELECT
         
         CASE 1
          SELECT CASE c2
           CASE IS < 0
                CALL DQBtri(1, dx2, dy2, dx4, dy4, dx1, dy1, ABS(c2))
           CASE IS > 0
                CALL DQBttri(1, dx2, dy2, dx4, dy4, dx1, dy1, p2x1, p2y1, p2x2, p2y2, p2x3, p2y3, VARSEG(buff2(goff * c2)), VARPTR(buff2(goff * c2)))
           END SELECT
          SELECT CASE c1
           CASE IS < 0
                CALL DQBtri(1, dx2, dy2, dx3, dy3, dx4, dy4, ABS(c1))
           CASE IS > 0
                CALL DQBttri(1, dx2, dy2, dx3, dy3, dx4, dy4, p1x1, p1y1, p1x2, p1y2, p1x3, p1y3, VARSEG(buff2(goff * c1)), VARPTR(buff2(goff * c1)))
           END SELECT
       
        END SELECT

END SELECT


IF smap(vx, vy) > 0 THEN
az1 = pnt(poly(vx, vy).v1).vz
az2 = pnt(poly(vx, vy).v2).vz
az3 = pnt(poly(vx, vy).v3).vz
az4 = pnt(poly(vx, vy).v4).vz
    z = INT((az1 + az2 + az3 + az4) / 4)

ax1 = pnt(poly(vx, vy).v1).sx
ax2 = pnt(poly(vx, vy).v2).sx
ax3 = pnt(poly(vx, vy).v3).sx
ax4 = pnt(poly(vx, vy).v4).sx
   ax = INT((ax1 + ax2 + ax3 + ax4) / 4)
ay1 = pnt(poly(vx, vy).v1).sy
ay2 = pnt(poly(vx, vy).v2).sy
ay3 = pnt(poly(vx, vy).v3).sy
ay4 = pnt(poly(vx, vy).v4).sy
   ay = INT((ay1 + ay2 + ay3 + ay4) / 4)


fx1 = -16
fx2 = 16
fy1 = -32
fy2 = 0

fx1 = (fx1 / (z / 10)) + ax
fx2 = (fx2 / (z / 10)) + ax
fy1 = (fy1 / (z / 10)) + ay
fy2 = (fy2 / (z / 10)) + ay

w = fx2 - fx1: h = fy2 - fy1

k = gview(a%, pa)

CALL DQBsput(1, fx1, fy1, VARSEG(buff1(k * goff)), VARPTR(buff1(k * goff)), w, h)

smap(vx, vy) = 0
END IF



END IF

NEXT x
NEXT y

END SUB

FUNCTION edangle% (a%)
 DO
  IF a% > 360 THEN a% = a% - 360
  IF a% < 0 THEN a% = a% + 360
 LOOP UNTIL a% > -1 AND a% < 361
 edangle% = a%
END FUNCTION

SUB edloc (gx%, gy%)
    
     IF gx% > 15 THEN gx% = 15
     IF gx% < 1 THEN gx% = 1
    
     IF gy% > 15 THEN gy% = 15
     IF gy% < 1 THEN gy% = 1

     
x1 = pnt(poly(gx%, gy%).v1).x
x2 = pnt(poly(gx%, gy%).v2).x
x3 = pnt(poly(gx%, gy%).v3).x
x4 = pnt(poly(gx%, gy%).v4).x
   px = -(INT((x1 + x2 + x3 + x4) / 4))

y1 = pnt(poly(gx%, gy%).v1).y
y2 = pnt(poly(gx%, gy%).v2).y
y3 = pnt(poly(gx%, gy%).v3).y
y4 = pnt(poly(gx%, gy%).v4).y
   py = -(INT((y1 + y2 + y3 + y4) / 4))

z1 = pnt(poly(gx%, gy%).v1).z
z2 = pnt(poly(gx%, gy%).v2).z
z3 = pnt(poly(gx%, gy%).v3).z
z4 = pnt(poly(gx%, gy%).v4).z
   pz = -(INT((z1 + z2 + z3 + z4) / 4))

  
END SUB

FUNCTION edpnt% (x%, y%)
 
  tt = ((y% - 1) * 16) + (x% - 1)
  edpnt% = tt

END FUNCTION

FUNCTION findturn% (oa%, ea%)

'/////////////////////////////////////////////////////
'////////////////////////FIND TURNING DIRECTION///////
'////////////////////oa% = my current angle///////////
'////////////////////ea% = the angle I want to face///
'////////////////////RETURNS [-1] [0] [1]/////////////

 t% = -1
 IF ea% > oa% THEN t% = 1
  IF ea% > 270 AND oa% < 90 THEN t% = -1
  IF ea% < 90 AND oa% > 270 THEN t% = 1
  IF ea% = oa% THEN t% = 0
 findturn% = t%

END FUNCTION

FUNCTION gview% (a1%, a2%)
  'a2% = a2% + (findturn%(a1%, a2%) * 5)
 na = edangle%(a1% + a2%)
  gv% = na / 45
    gv% = 8 - gv%
   IF gv% < 0 THEN gv% = 7
   IF gv% > 7 THEN gv% = 0
  gview% = gv%

END FUNCTION

SUB loadmap (n$)
  OPEN n$ FOR INPUT AS #1

 FOR i = 0 TO 256
 INPUT #1, pnt(i).x
 INPUT #1, pnt(i).y
 INPUT #1, pnt(i).z
 INPUT #1, pnt(i).vz
 INPUT #1, pnt(i).sx
 INPUT #1, pnt(i).sy
 INPUT #1, pnt(i).ss
 INPUT #1, pnt(i).effect
 INPUT #1, pnt(i).effdat1
 INPUT #1, pnt(i).effdat2
 INPUT #1, pnt(i).effdat3
 NEXT i

FOR y = 1 TO 15
FOR x = 1 TO 15
INPUT #1, poly(x, y).v1
INPUT #1, poly(x, y).v2
INPUT #1, poly(x, y).v3
INPUT #1, poly(x, y).v4
INPUT #1, poly(x, y).ord
INPUT #1, poly(x, y).ge1
INPUT #1, poly(x, y).ge2
INPUT #1, poly(x, y).tex1
INPUT #1, poly(x, y).tdat1.p1.x
INPUT #1, poly(x, y).tdat1.p1.y
INPUT #1, poly(x, y).tdat1.p2.x
INPUT #1, poly(x, y).tdat1.p2.y
INPUT #1, poly(x, y).tdat1.p3.x
INPUT #1, poly(x, y).tdat1.p3.y
INPUT #1, poly(x, y).tex2
INPUT #1, poly(x, y).tdat2.p1.x
INPUT #1, poly(x, y).tdat2.p1.y
INPUT #1, poly(x, y).tdat2.p2.x
INPUT #1, poly(x, y).tdat2.p2.y
INPUT #1, poly(x, y).tdat2.p3.x
INPUT #1, poly(x, y).tdat2.p3.y
INPUT #1, poly(x, y).teffect1
INPUT #1, poly(x, y).teffect2

IF poly(x, y).tex1 > 39 THEN
poly(x, y).tex1 = 41
poly(x, y).teffect1 = INT(RND * 8)
END IF

IF poly(x, y).tex2 > 39 THEN
poly(x, y).tex2 = 41
poly(x, y).teffect2 = INT(RND * 8)
END IF




NEXT x
NEXT y

CLOSE #1

END SUB

SUB lutsc

FOR i = 0 TO 360
 co(i) = COS(i * 3.141593 / 180)
 si(i) = SIN(i * 3.141593 / 180)
NEXT i

END SUB

SUB makepmap

c = 0

FOR y = -256 TO 224 STEP 32
FOR x = -256 TO 224 STEP 32
 
  pnt(c).x = x
  pnt(c).y = y
  pnt(c).z = 0' INT(RND * 50) - 25
   

 c = c + 1

NEXT x
NEXT y



END SUB

SUB makepoly

FOR y = 1 TO 15
FOR x = 1 TO 15
  p = ((y - 1) * 16) + (x - 1)

 poly(x, y).v1 = p
 poly(x, y).v2 = p + 1
 poly(x, y).v3 = p + 17
 poly(x, y).v4 = p + 16
 poly(x, y).ord = 0
   t1 = INT(RND * 33) + 1
   t2 = INT(RND * 33) + 1

IF t1 > 33 THEN poly(x, y).tex1 = -(INT(RND * 255) + 1) ELSE poly(x, y).tex1 = t1
IF t2 > 33 THEN poly(x, y).tex2 = -(INT(RND * 255) + 1) ELSE poly(x, y).tex2 = t2
poly(x, y).tex1 = 11
poly(x, y).tex2 = 11
' IF y > 11 THEN
'poly(x, y).tex1 = 42
'poly(x, y).tex2 = 42
'  END IF
  poly(x, y).tdat1.p1.x = 1
  poly(x, y).tdat1.p1.y = 1
  poly(x, y).tdat1.p2.x = 32
  poly(x, y).tdat1.p2.y = 1
  poly(x, y).tdat1.p3.x = 32
  poly(x, y).tdat1.p3.y = 32
 
  poly(x, y).tdat2.p1.x = 1
  poly(x, y).tdat2.p1.y = 1
  poly(x, y).tdat2.p2.x = 32
  poly(x, y).tdat2.p2.y = 1
  poly(x, y).tdat2.p3.x = 32
  poly(x, y).tdat2.p3.y = 32

NEXT x
NEXT y

END SUB

SUB mksprite

bp$ = "pack1.pkg"

g = DQBloadLayer(2, bp$, palt)

FOR x = 1 TO 8

CALL DQBget(2, (x * 32), 0, (x * 32) + 31, 32, VARSEG(buff1(goff * (x - 1))), VARPTR(buff1(goff * (x - 1))))

NEXT x

bp$ = "pack2.pkg"

g = DQBloadLayer(2, bp$, palt)


t = 0
FOR y = 0 TO 4
FOR x = 0 TO 9
 CALL DQBget(2, (x * 32), (y * 32), (x * 32) + 31, (y * 32) + 31, VARSEG(buff2(goff * t)), VARPTR(buff2(goff * t)))
t = t + 1
NEXT x
NEXT y


bp$ = "pack3.pkg"

g = DQBloadLayer(2, bp$, palt)


END SUB

SUB savemap (n$)
 
  OPEN n$ FOR OUTPUT AS #1

 FOR i = 0 TO 256
 PRINT #1, pnt(i).x
 PRINT #1, pnt(i).y
 PRINT #1, pnt(i).z
 PRINT #1, pnt(i).vz
 PRINT #1, pnt(i).sx
 PRINT #1, pnt(i).sy
 PRINT #1, pnt(i).ss
 PRINT #1, pnt(i).effect
 PRINT #1, pnt(i).effdat1
 PRINT #1, pnt(i).effdat2
 PRINT #1, pnt(i).effdat3
 NEXT i

FOR y = 1 TO 15
FOR x = 1 TO 15
PRINT #1, poly(x, y).v1
PRINT #1, poly(x, y).v2
PRINT #1, poly(x, y).v3
PRINT #1, poly(x, y).v4
PRINT #1, poly(x, y).ord
PRINT #1, poly(x, y).ge1
PRINT #1, poly(x, y).ge2
PRINT #1, poly(x, y).tex1
PRINT #1, poly(x, y).tdat1.p1.x
PRINT #1, poly(x, y).tdat1.p1.y
PRINT #1, poly(x, y).tdat1.p2.x
PRINT #1, poly(x, y).tdat1.p2.y
PRINT #1, poly(x, y).tdat1.p3.x
PRINT #1, poly(x, y).tdat1.p3.y
PRINT #1, poly(x, y).tex2
PRINT #1, poly(x, y).tdat2.p1.x
PRINT #1, poly(x, y).tdat2.p1.y
PRINT #1, poly(x, y).tdat2.p2.x
PRINT #1, poly(x, y).tdat2.p2.y
PRINT #1, poly(x, y).tdat2.p3.x
PRINT #1, poly(x, y).tdat2.p3.y
PRINT #1, poly(x, y).teffect1
PRINT #1, poly(x, y).teffect2

NEXT x
NEXT y

CLOSE #1
END SUB

